<?php
/*
Plugin Name: Fast Tube
Plugin URI: http://blog.caspie.net/2009/02/19/fast-tube-wordpress-plugin/
Description: Fast and easy way to insert videos from YouTube right into your WordPress blog posts.
Version: 2.0
Author: Casper
Author URI: http://blog.caspie.net/
*/
add_filter('the_content','fast_youtube_content',50);
function fast_youtube_content($the_content) {
 	$options = get_option('fast_tube_options');
 	$author = $options['author'] ? '<br /><small>Fast Tube '.FAST_TUBE_VERSION.' by <a title="Casper\'s Blog" href="http://blog.caspie.net/">Casper</a></small>' : '';
 	$align_class = $options['alignclass'] != '' ? ' class="'.$options['alignclass'].'"' : '';
 	$align_after = $options['align'] ? '</'.$options['aligntag'].'>' : '</span>';
 	$align_display = $options['aligntag'] == 'span' ? 'display:block;' : '';
	$pat = "/\[((http:\/\/)?(www\.)?youtube\.com\/)?((watch\?)?v=|v\/)?([a-zA-Z0-9\-\_]{11}).*\]/";
	if(preg_match_all($pat,$the_content,$matches,PREG_SET_ORDER)) {
		foreach ($matches as $match) {
			if(file_get_contents("http://gdata.youtube.com/feeds/api/videos/".$match[6]) != "Video not found") {
 			$align_before = $options['align'] ? '<'.$options['aligntag'].' id="'.$match[6].'"'.$align_class.' style="text-align:'.$options['alignment'].';'.$align_display.'">' : '<span id="'.$match[6].'" style="display:block;">';
			$video = 'http://www.youtube.com/v/'.$match[6].'&amp;hl=en&amp;fs='.(int)$options['fullscreen'].'&amp;border='.(int)$options['border'].'&amp;color1='.$options['color1'].'&amp;color2='.$options['color2'].'&amp;egm='.(int)$options['egm'].'&amp;disablekb='.(int)$options['disablekb'].'&amp;autoplay='.(int)$options['autoplay'].'&amp;loop='.(int)$options['loop'].'&amp;rel='.(int)$options['related'].'&amp;showinfo='.(int)$options['info'].'&amp;showsearch='.(int)$options['search'].'&amp;iv_load_policy='.$options['annotations'].'&amp;start='.(int)$options['start'];
				if((!is_singular() && $options['thumb']) || is_feed()) {
					$vid = '<!--[Fast Tube]-->'.$align_before.'<a title="Click here to watch this video!" href="'.get_permalink().'#'.$match[6].'"><img src="http://i.ytimg.com/vi/'.$match[6].'/'.(int)$options['thumbnail'].'.jpg" alt="Fast Tube" border="0" /></a>'.$author.$align_after.'<!--[/Fast Tube]-->';
				}
				else {
					$options['valid'] ? $vid = '<!-- [Fast Tube] -->'.$align_before.'<object type="application/x-shockwave-flash" width="'.$options['width'].'" height="'.$options['height'].'" data="'.$video.'"><param name="movie" value="'.$video.'"></param><param name="allowFullScreen" value="true"></param><param name="wmode" value="transparent"></param></object>'.$author.$align_after.'<!-- [/Fast Tube] -->' : $vid = '<!-- [Fast Tube] -->'.$align_before.'<object width="'.$options['width'].'" height="'.$options['height'].'"><param name="movie" value="'.$video.'"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="'.$video.'" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="'.$options['width'].'" height="'.$options['height'].'"></embed></object>'.$author.$align_after.'<!-- [/Fast Tube] -->';
				}
			}
			else { $vid = $match[0]; }
			$the_content = str_replace($match[0],$vid,$the_content);
		}
	}
	return $the_content;
}
add_action('admin_menu', 'fast_tube_menu');
function fast_tube_menu() {
	add_options_page('Fast Tube', 'Fast Tube', 8, __FILE__, 'fast_tube_options');
}
function fast_tube_options() {
	$option = array ('width','height','border','color1','color2','fullscreen','egm','disablekb','autoplay','loop','related','info','search','annotations','start','align','alignment','aligntag','alignclass','thumb','thumbnail','valid','author');
	if(isset($_POST['submit'])) {
		check_admin_referer('fast_tube');
		$new_options = $_POST['fast_tube'];
		foreach($option as $isset) {
			switch($isset) {
				case 'width':
				$options[$isset] = $new_options[$isset] == '' ? 425 : (int)$new_options[$isset];
				break;
				case 'height':
				$options[$isset] = $new_options[$isset] == '' ? 344 : (int)$new_options[$isset];
				break;
				case 'color1':
				$options[$isset] = $new_options[$isset] == '' ? '999999' : ltrim($new_options[$isset],'#');
				break;
				case 'color2':
				$options[$isset] = $new_options[$isset] == '' ? 'cccccc' : ltrim($new_options[$isset],'#');
				break;
				case 'annotations':
				$options[$isset] = isset($new_options[$isset]) ? 1 : 3;
				break;
				case 'start':
				$options[$isset] = $new_options[$isset] == '' ? 0 : (int)$new_options[$isset];
				break;
				case ('alignment' || 'aligntag' || 'alignclass'):
				$options[$isset] = $new_options[$isset];
				break;
				case 'thumbnail':
				$options[$isset] = (bool)$new_options[$isset];
				break;
				default:
				$options[$isset] = isset($new_options[$isset]);
			}
		}
		update_option('fast_tube_options',$options);
		echo '<div id="message" class="updated fade"><p><strong>Settings Saved.</strong></p></div>';
	}
	if(isset($_POST['reset'])) {
		fast_tube_start(true);
		echo '<div id="message" class="updated fade"><p><strong>Default Settings Loaded.</strong></p></div>';
	}
	$options = get_option('fast_tube_options');
	$action = $_SERVER['REQUEST_URI'];
	$checked = array ('border','fullscreen','egm','disablekb','autoplay','loop','related','info','search','annotations','align','center','left','right','span','div','p','thumb','thumbnail','valid','author');
	foreach($option as $checked) {
		switch($checked) {
			case 'annotations':
			$$checked = $options[$checked] == 1 ? ' checked="checked"' : '';
			break;
			case ('center' || 'left' || 'right'):
			$$checked = $options['alignment'] == $checked ? ' selected="selected"': '';
			break;
			case ('span' || 'div' || 'p'):
			$$checked = $options['aligntag'] == $checked ? ' selected="selected"': '';
			break;
			case 'thumbnail':
			$$checked = $options[$checked] ? $small = ' selected="selected"' : $big = ' selected="selected"';
			break;
			default:
			$$checked = $options[$checked] ? ' checked="checked"' : '';
		}
	}
	$path = defined('WP_PLUGIN_URL') ? trailingslashit(WP_PLUGIN_URL . '/' . dirname(plugin_basename(__FILE__))) : trailingslashit(get_bloginfo('wpurl')) . PLUGINDIR . '/' . dirname(plugin_basename(__FILE__));
	echo '<script src="'.$path.'/js/301a.js" type="text/javascript"></script><div class="wrap">
		<h2>Fast Tube '.FAST_TUBE_VERSION.' by <a title="Casper\'s Blog" href="http://blog.caspie.net/">Casper</a></h2>
		<h5>Check out my other WordPress plugins at <a title="Downloads @ Casper\'s Blog" href="http://blog.caspie.net/downloads/">http://blog.caspie.net/downloads</a><br />Nice plugin eh? Feel free to <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&amp;business=R7HRD7C3JDDN8&amp;lc=GB&amp;item_name=WordPress%20Plugins%20by%20Casper&amp;currency_code=EUR&amp;bn=PP%2dDonationsBF%3abtn_donateCC_LG_global%2egif%3aNonHosted" target="_blank">donate</a> if you like it. Thanks and have fun! :></h5>
		<h2>Video Options:</h2><div id="colorpicker301" class="colorpicker301"></div>
		<form method="post" action="'.$action.'">';
	wp_nonce_field('fast_tube');
	echo '<table class="form-table" style="width:520px;">
		<tr valign="top">
		<td width="100%">&rarr; <em>Video width in pixels</em></td>
		<td class="ri"><input type="text" name="fast_tube[width]" value="'.$options['width'].'" size="4" /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more1\');" value="more" />
		<div id="more1" class="more" style="display:none;">
		<div><small>This is the width (in pixels) of the YouTube videos.</small><h5>YouTube default setting: 425 pixels</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Video height in pixels</em></td>
		<td class="ri"><input type="text" name="fast_tube[height]" value="'.$options['height'].'" size="4" /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more2\');" value="more" />
		<div id="more2" class="more" style="display:none;">
		<div><small>This is the height (in pixels) of the YouTube videos.</small><h5>YouTube default setting: 344 pixels</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Enable a border around the video player</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[border]" value="1"'.$border.' /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="text" id="sample_1" size="1" value="" style="background:#'.$options['color1'].'" /><input type="text" name="fast_tube[color1]" id="color_1" size="9" value="#'.$options['color1'].'" /> &rarr; <a title="Set Color 1" href="javascript:showColorGrid3(\'color_1\',\'sample_1\');">Select Primary Border Color</a><br /><input type="text" id="sample_2" size="1" value="" style="background:#'.$options['color2'].'" /><input type="text" name="fast_tube[color2]" id="color_2" size="9" value="#'.$options['color2'].'" /> &rarr; <a title="Set Color 2" href="javascript:showColorGrid3(\'color_2\',\'sample_2\');">Select Secondary Border Color</a></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more3\');" value="more" />
		<div id="more3" class="more" style="display:none;">
		<div><small>If checked, this option enables a border around the entire video player. The two colors are the primary and the secondary border colors. Feel free to play with the colors until you reach the result that will satisfy your needs.</small><h5>YouTube default setting: OFF</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Enable fullscreen button</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[fullscreen]" value="1"'.$fullscreen.' /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more4\');" value="more" />
		<div id="more4" class="more" style="display:none;">
		<div><small>If this is checked, the fullscreen button will be visible. Otherwise it will be hidden.</small><h5>YouTube default setting: ON</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Enable Enhanced Genie Menu</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[egm]" value="1"'.$egm.' /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more5\');" value="more" />
		<div id="more5" class="more" style="display:none;">
		<div><small>If checked, this option causes the genie menu to appear when the user\'s mouse enters the video display area, as opposed to only appearing when the menu button is pressed. Works if "Show related videos" option is also enabled.</small><h5>YouTube default setting: OFF</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Disable player keyboard controls</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[disablekb]" value="1"'.$disablekb.' /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more6\');" value="more" />
		<div id="more6" class="more" style="display:none;">
		<div><small>If checked, this option disables all player keyboard controls: 1) Spacebar: Play / Pause, 2) Arrow Left: Restart current video, 3)Arrow Right: Jump ahead 10% in the current video, 4) Arrow Up: Volume up, 5) Arrow Down: Volume Down.</small><h5>YouTube default setting: OFF</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Autoplay the videos</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[autoplay]" value="1"'.$autoplay.' /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more7\');" value="more" />
		<div id="more7" class="more" style="display:none;">
		<div><small>If this option is checked, the initial video will autoplay when the player loads.</small><h5>YouTube default setting: OFF</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Loop the videos</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[loop]" value="1"'.$loop.' /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more8\');" value="more" />
		<div id="more8" class="more" style="display:none;">
		<div><small>If this option is checked and it\'s a single video, the player will loop the video. But if it\'s a playlist player, the player will loop the whole playlist, starting from the first video.</small><h5>YouTube default setting: OFF</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Show related videos once playback starts</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[related]" value="1"'.$related.' /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more9\');" value="more" />
		<div id="more9" class="more" style="display:none;">
		<div><small>If this option is checked, the player will load related videos. Keep im mind that if this option is not checked the Enhanced Genie Menu and the Search box won\'t work.</small><h5>YouTube default setting: ON</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Show title and ratings before start</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[info]" value="1"'.$info.' /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more10\');" value="more" />
		<div id="more10" class="more" style="display:none;">
		<div><small>If checked you will be able to see the video title and ratings right before you start playing the video.</small><h5>YouTube default setting: ON</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Show search box when minimized</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[search]" value="1"'.$search.' /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more11\');" value="more" />
		<div id="more11" class="more" style="display:none;">
		<div><small>Enables the search box when the video is minimized. "Show related videos" must be enabled if you want this option to work".</small><h5>YouTube default setting: ON</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Show video annotations</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[annotations]" value="1"'.$annotations.' /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more12\');" value="more" />
		<div id="more12" class="more" style="display:none;">
		<div><small>If this option is checked, it will cause video annotations to be shown by default.</small><h5>YouTube default setting: ON</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Start video, skipping the first N seconds</em></td>
		<td class="ri"><input type="text" name="fast_tube[start]" value="'.$options['start'].'" size="4" /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more13\');" value="more" />
		<div id="more13" class="more" style="display:none;">
		<div><small>Enable this if you want to start the videos, skipping the amount of seconds you set.</small><h5>YouTube default setting: Starts from 0</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Set Fast Tube to auto align the videos</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[align]" value="1"'.$align.' /></td>
		</tr>
		<tr><td class="ri nb">Select the way you want Fast Tube to align your videos &rarr;</td><td class="ri nb">
		<select name="fast_tube[alignment]">
			<option value="center"'.$center.'>Center</option>
			<option value="left"'.$left.'>Left</option>
			<option value="right"'.$right.'>Right</option>
		</select>
		</td>
		</tr>
		<tr><td class="ri nb">Select the tag you want Fast Tube to use for alignment &rarr;</td><td class="ri nb">
		<select name="fast_tube[aligntag]">
			<option value="span"'.$span.'>span</option>
			<option value="div"'.$div.'>div</option>
			<option value="p"'.$p.'>p</option>
		</select>
		</td>
		</tr>
		<tr><td class="ri nb">Enter class name that you want to assign to the align tag &rarr;</td><td class="ri nb">
		<input type="text" name="fast_tube[alignclass]" value="'.$options['alignclass'].'" size="7" />
		</td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more14\');" value="more" />
		<div id="more14" class="more" style="display:none;">
		<div><small>If you don\'t want to waste time aligning the videos through the Post/Page editor, Fast Tube can do it automatically. You can choose the direction of alignment - center, left or right and the block element you want to put the videos into - div, p, span. Keep in mind that "span" is an inline element, so it is always styled with "display:block;" here. Use div or p if you don\'t mind that your code won\'t be a valid XHTML code. Block elements just break it. Additionally, you can add class or classes (separated by space, of course) to style the selected alignment tag. Use classes from the style.css of your current theme or just add some new there.</small><h5>Fast Tube default setting: OFF</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Set Fast Tube to display thumb if not on single post or page</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[thumb]" value="1"'.$thumb.' /></td>
		</tr>
		<tr><td class="ri nb">Select the size of the thumbnail &rarr;</td><td class="ri nb">
		<select name="fast_tube[thumbnail]">
			<option value="0"'.$big.'>320x240</option>
			<option value="1"'.$small.'>128x96</option>
		</select>
		</td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more15\');" value="more" />
		<div id="more15" class="more" style="display:none;">
		<div><small>Enable this if you want Fast Tube to show thumbnail instead of video player if not on a single post or page. It is very useful if you put a lot of videos on your index page for example. Using thumbnails will cause your blog to load faster. There are two default thumbnail sizes you can choose from. Note that clicking the thumb will lead you right to the video player. It\'s same as when clicking the permalink of your post.</small><h5>Fast Tube default setting: OFF</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Use Valid XHTML Code</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[valid]" value="1"'.$valid.' /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more16\');" value="more" />
		<div id="more16" class="more" style="display:none;">
		<div><small>You already know that YouTube gives you some old and junky code, which validators don\'t like very much. Keep this enabled and forget about the validation errors.</small><h5>Fast Tube default setting: ON</h5></div>
		</div></td></tr>
		<tr valign="top">
		<td>&rarr; <em>Display small info about the author under the video</em></td>
		<td class="ri"><input type="checkbox" name="fast_tube[author]" value="1"'.$author.' /></td>
		</tr>
		<tr><td colspan="2" class="nb"><input type="button" class="button" onclick="javascript:moreInfo(\'more17\');" value="more" />
		<div id="more17" class="more" style="display:none;">
		<div><small>This will show a small text - <strong>Fast Tube [version] by Casper</strong> - under your videos. If you appreciate my work you are free to support this plugin by keeping this option enabled as you are free to <a title="WordPress Plugins by Casper" href="http://blog.caspie.net/downloads/" target="_blank">check out my other WordPress plugins or to make a donation</a>. Thanks in advance!</small><h5>Fast Tube default setting: ON</h5></div>
		</div></td></tr>
		</table>
		<input type="hidden" name="action" value="update" />';
?>
		<p class="submit" style="width:520px;text-align:center;">
		<input type="submit" name="submit" class="button" value="Save Changes" /><input type="submit" name="reset" class="button" value="Reset to Defaults" />
		</p>
		</form></div>
<script type="text/javascript">
<!--
function moreInfo(obj) {
	var el = document.getElementById(obj);
	if ( el.style.display != 'none' ) {
		el.style.display = 'none';
	}
	else {
		el.style.display = 'block';
	}
}
//-->
</script>
<style type="text/css" media="screen">
	input[type=checkbox] { border:0 none; }
	input[type=text] { vertical-align:middle; }
	td { border-top:1px solid #ccc;background:#eee; }
	select { width:80px; }
	.more { border:1px dashed #ccc;background:#fff;margin-top:10px;padding:5px; }
	.ri { text-align:right; }
	.nb { border:0 none; }
</style>
<?php
}
add_action('plugins_loaded', 'fast_tube_start');
function fast_tube_start($reset) {
	$all_options = array(
		'width' => 425,
		'height' => 344,
		'border' => false,
		'color1' => '999999',
		'color2' => 'cccccc',
		'fullscreen' => true,
		'egm' => false,
		'disablekb' => false,
		'autoplay' => false,
		'loop' => false,
		'related' => true,
		'info' => true,
		'search' => true,
		'annotations' => 1,
		'start' => 0,
		'align' => false,
		'alignment' => 'center',
		'aligntag' => 'span',
		'alignclass' => '',
		'thumb' => false,
		'thumbnail' => false,
		'valid' => true,
		'author' => true
	);
	$reset ? update_option('fast_tube_options',$all_options) : add_option('fast_tube_options',$all_options);
}
define('FAST_TUBE_VERSION','2.0');
?>